// Code generated by BobGen psql v0.22.0. DO NOT EDIT.
// This file is meant to be re-generated in place and/or deleted at any time.

package factory

import (
	"context"

	models "github.com/AlienList/backend-watchlist/bob"
	"github.com/aarondl/opt/null"
	"github.com/aarondl/opt/omit"
	"github.com/aarondl/opt/omitnull"
	"github.com/jaswdr/faker"
	"github.com/stephenafamo/bob"
)

type AnimeMod interface {
	Apply(*AnimeTemplate)
}

type AnimeModFunc func(*AnimeTemplate)

func (f AnimeModFunc) Apply(n *AnimeTemplate) {
	f(n)
}

type AnimeModSlice []AnimeMod

func (mods AnimeModSlice) Apply(n *AnimeTemplate) {
	for _, f := range mods {
		f.Apply(n)
	}
}

// AnimeTemplate is an object representing the database table.
// all columns are optional and should be set by mods
type AnimeTemplate struct {
	ID                func() int
	Romaji            func() null.Val[string]
	English           func() null.Val[string]
	Native            func() null.Val[string]
	Format            func() null.Val[string]
	Status            func() null.Val[string]
	Description       func() null.Val[string]
	StartYear         func() null.Val[int]
	StartMonth        func() null.Val[int]
	StartDay          func() null.Val[int]
	EndYear           func() null.Val[int]
	EndMonth          func() null.Val[int]
	EndDay            func() null.Val[int]
	Season            func() null.Val[string]
	SeasonYear        func() null.Val[string]
	Episodes          func() null.Val[string]
	Duration          func() null.Val[string]
	CountryOfOrigin   func() null.Val[string]
	UpdatedAt         func() null.Val[int]
	CoverImage        func() null.Val[string]
	AverageScore      func() null.Val[int]
	Popularity        func() null.Val[int]
	AiringAt          func() null.Val[int]
	NextAiringEpisode func() null.Val[int]

	r animeR
	f *Factory
}

type animeR struct {
	Watchlists []*animeRWatchlistsR
}

type animeRWatchlistsR struct {
	number int
	o      *WatchlistTemplate
}

// Apply mods to the AnimeTemplate
func (o *AnimeTemplate) Apply(mods ...AnimeMod) {
	for _, mod := range mods {
		mod.Apply(o)
	}
}

// toModel returns an *models.Anime
// this does nothing with the relationship templates
func (o AnimeTemplate) toModel() *models.Anime {
	m := &models.Anime{}

	if o.ID != nil {
		m.ID = o.ID()
	}
	if o.Romaji != nil {
		m.Romaji = o.Romaji()
	}
	if o.English != nil {
		m.English = o.English()
	}
	if o.Native != nil {
		m.Native = o.Native()
	}
	if o.Format != nil {
		m.Format = o.Format()
	}
	if o.Status != nil {
		m.Status = o.Status()
	}
	if o.Description != nil {
		m.Description = o.Description()
	}
	if o.StartYear != nil {
		m.StartYear = o.StartYear()
	}
	if o.StartMonth != nil {
		m.StartMonth = o.StartMonth()
	}
	if o.StartDay != nil {
		m.StartDay = o.StartDay()
	}
	if o.EndYear != nil {
		m.EndYear = o.EndYear()
	}
	if o.EndMonth != nil {
		m.EndMonth = o.EndMonth()
	}
	if o.EndDay != nil {
		m.EndDay = o.EndDay()
	}
	if o.Season != nil {
		m.Season = o.Season()
	}
	if o.SeasonYear != nil {
		m.SeasonYear = o.SeasonYear()
	}
	if o.Episodes != nil {
		m.Episodes = o.Episodes()
	}
	if o.Duration != nil {
		m.Duration = o.Duration()
	}
	if o.CountryOfOrigin != nil {
		m.CountryOfOrigin = o.CountryOfOrigin()
	}
	if o.UpdatedAt != nil {
		m.UpdatedAt = o.UpdatedAt()
	}
	if o.CoverImage != nil {
		m.CoverImage = o.CoverImage()
	}
	if o.AverageScore != nil {
		m.AverageScore = o.AverageScore()
	}
	if o.Popularity != nil {
		m.Popularity = o.Popularity()
	}
	if o.AiringAt != nil {
		m.AiringAt = o.AiringAt()
	}
	if o.NextAiringEpisode != nil {
		m.NextAiringEpisode = o.NextAiringEpisode()
	}

	return m
}

// toModels returns an models.AnimeSlice
// this does nothing with the relationship templates
func (o AnimeTemplate) toModels(number int) models.AnimeSlice {
	m := make(models.AnimeSlice, number)

	for i := range m {
		m[i] = o.toModel()
	}

	return m
}

// setModelRels creates and sets the relationships on *models.Anime
// according to the relationships in the template. Nothing is inserted into the db
func (t AnimeTemplate) setModelRels(o *models.Anime) {
	if t.r.Watchlists != nil {
		rel := models.WatchlistSlice{}
		for _, r := range t.r.Watchlists {
			related := r.o.toModels(r.number)
			for _, rel := range related {
				rel.AnimeID = o.ID
				rel.R.Anime = o
			}
			rel = append(rel, related...)
		}
		o.R.Watchlists = rel
	}

}

// BuildSetter returns an *models.AnimeSetter
// this does nothing with the relationship templates
func (o AnimeTemplate) BuildSetter() *models.AnimeSetter {
	m := &models.AnimeSetter{}

	if o.ID != nil {
		m.ID = omit.From(o.ID())
	}
	if o.Romaji != nil {
		m.Romaji = omitnull.FromNull(o.Romaji())
	}
	if o.English != nil {
		m.English = omitnull.FromNull(o.English())
	}
	if o.Native != nil {
		m.Native = omitnull.FromNull(o.Native())
	}
	if o.Format != nil {
		m.Format = omitnull.FromNull(o.Format())
	}
	if o.Status != nil {
		m.Status = omitnull.FromNull(o.Status())
	}
	if o.Description != nil {
		m.Description = omitnull.FromNull(o.Description())
	}
	if o.StartYear != nil {
		m.StartYear = omitnull.FromNull(o.StartYear())
	}
	if o.StartMonth != nil {
		m.StartMonth = omitnull.FromNull(o.StartMonth())
	}
	if o.StartDay != nil {
		m.StartDay = omitnull.FromNull(o.StartDay())
	}
	if o.EndYear != nil {
		m.EndYear = omitnull.FromNull(o.EndYear())
	}
	if o.EndMonth != nil {
		m.EndMonth = omitnull.FromNull(o.EndMonth())
	}
	if o.EndDay != nil {
		m.EndDay = omitnull.FromNull(o.EndDay())
	}
	if o.Season != nil {
		m.Season = omitnull.FromNull(o.Season())
	}
	if o.SeasonYear != nil {
		m.SeasonYear = omitnull.FromNull(o.SeasonYear())
	}
	if o.Episodes != nil {
		m.Episodes = omitnull.FromNull(o.Episodes())
	}
	if o.Duration != nil {
		m.Duration = omitnull.FromNull(o.Duration())
	}
	if o.CountryOfOrigin != nil {
		m.CountryOfOrigin = omitnull.FromNull(o.CountryOfOrigin())
	}
	if o.UpdatedAt != nil {
		m.UpdatedAt = omitnull.FromNull(o.UpdatedAt())
	}
	if o.CoverImage != nil {
		m.CoverImage = omitnull.FromNull(o.CoverImage())
	}
	if o.AverageScore != nil {
		m.AverageScore = omitnull.FromNull(o.AverageScore())
	}
	if o.Popularity != nil {
		m.Popularity = omitnull.FromNull(o.Popularity())
	}
	if o.AiringAt != nil {
		m.AiringAt = omitnull.FromNull(o.AiringAt())
	}
	if o.NextAiringEpisode != nil {
		m.NextAiringEpisode = omitnull.FromNull(o.NextAiringEpisode())
	}

	return m
}

// BuildManySetter returns an []*models.AnimeSetter
// this does nothing with the relationship templates
func (o AnimeTemplate) BuildManySetter(number int) []*models.AnimeSetter {
	m := make([]*models.AnimeSetter, number)

	for i := range m {
		m[i] = o.BuildSetter()
	}

	return m
}

// Build returns an *models.Anime
// Related objects are also created and placed in the .R field
// NOTE: Objects are not inserted into the database. Use AnimeTemplate.Create
func (o AnimeTemplate) Build() *models.Anime {
	m := o.toModel()
	o.setModelRels(m)

	return m
}

// BuildMany returns an models.AnimeSlice
// Related objects are also created and placed in the .R field
// NOTE: Objects are not inserted into the database. Use AnimeTemplate.CreateMany
func (o AnimeTemplate) BuildMany(number int) models.AnimeSlice {
	m := make(models.AnimeSlice, number)

	for i := range m {
		m[i] = o.Build()
	}

	return m
}

func ensureCreatableAnime(m *models.AnimeSetter) {
}

// insertOptRels creates and inserts any optional the relationships on *models.Anime
// according to the relationships in the template.
// any required relationship should have already exist on the model
func (o *AnimeTemplate) insertOptRels(ctx context.Context, exec bob.Executor, m *models.Anime) (context.Context, error) {
	var err error

	if o.r.Watchlists != nil {
		for _, r := range o.r.Watchlists {
			var rel0 models.WatchlistSlice
			ctx, rel0, err = r.o.createMany(ctx, exec, r.number)
			if err != nil {
				return ctx, err
			}

			err = m.AttachWatchlists(ctx, exec, rel0...)
			if err != nil {
				return ctx, err
			}
		}
	}

	return ctx, err
}

// Create builds a anime and inserts it into the database
// Relations objects are also inserted and placed in the .R field
func (o *AnimeTemplate) Create(ctx context.Context, exec bob.Executor) (*models.Anime, error) {
	_, m, err := o.create(ctx, exec)
	return m, err
}

// create builds a anime and inserts it into the database
// Relations objects are also inserted and placed in the .R field
// this returns a context that includes the newly inserted model
func (o *AnimeTemplate) create(ctx context.Context, exec bob.Executor) (context.Context, *models.Anime, error) {
	var err error
	opt := o.BuildSetter()
	ensureCreatableAnime(opt)

	m, err := models.Animes.Insert(ctx, exec, opt)
	if err != nil {
		return ctx, nil, err
	}
	ctx = animeCtx.WithValue(ctx, m)

	ctx, err = o.insertOptRels(ctx, exec, m)
	return ctx, m, err
}

// CreateMany builds multiple animes and inserts them into the database
// Relations objects are also inserted and placed in the .R field
func (o AnimeTemplate) CreateMany(ctx context.Context, exec bob.Executor, number int) (models.AnimeSlice, error) {
	_, m, err := o.createMany(ctx, exec, number)
	return m, err
}

// createMany builds multiple animes and inserts them into the database
// Relations objects are also inserted and placed in the .R field
// this returns a context that includes the newly inserted models
func (o AnimeTemplate) createMany(ctx context.Context, exec bob.Executor, number int) (context.Context, models.AnimeSlice, error) {
	var err error
	m := make(models.AnimeSlice, number)

	for i := range m {
		ctx, m[i], err = o.create(ctx, exec)
		if err != nil {
			return ctx, nil, err
		}
	}

	return ctx, m, nil
}

// Anime has methods that act as mods for the AnimeTemplate
var AnimeMods animeMods

type animeMods struct{}

func (m animeMods) RandomizeAllColumns(f *faker.Faker) AnimeMod {
	return AnimeModSlice{
		AnimeMods.RandomID(f),
		AnimeMods.RandomRomaji(f),
		AnimeMods.RandomEnglish(f),
		AnimeMods.RandomNative(f),
		AnimeMods.RandomFormat(f),
		AnimeMods.RandomStatus(f),
		AnimeMods.RandomDescription(f),
		AnimeMods.RandomStartYear(f),
		AnimeMods.RandomStartMonth(f),
		AnimeMods.RandomStartDay(f),
		AnimeMods.RandomEndYear(f),
		AnimeMods.RandomEndMonth(f),
		AnimeMods.RandomEndDay(f),
		AnimeMods.RandomSeason(f),
		AnimeMods.RandomSeasonYear(f),
		AnimeMods.RandomEpisodes(f),
		AnimeMods.RandomDuration(f),
		AnimeMods.RandomCountryOfOrigin(f),
		AnimeMods.RandomUpdatedAt(f),
		AnimeMods.RandomCoverImage(f),
		AnimeMods.RandomAverageScore(f),
		AnimeMods.RandomPopularity(f),
		AnimeMods.RandomAiringAt(f),
		AnimeMods.RandomNextAiringEpisode(f),
	}
}

// Set the model columns to this value
func (m animeMods) ID(val int) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.ID = func() int { return val }
	})
}

// Set the Column from the function
func (m animeMods) IDFunc(f func() int) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.ID = f
	})
}

// Clear any values for the column
func (m animeMods) UnsetID() AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.ID = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m animeMods) RandomID(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.ID = func() int {
			return random[int](f)
		}
	})
}

func (m animeMods) ensureID(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		if o.ID != nil {
			return
		}

		o.ID = func() int {
			return random[int](f)
		}
	})
}

// Set the model columns to this value
func (m animeMods) Romaji(val null.Val[string]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Romaji = func() null.Val[string] { return val }
	})
}

// Set the Column from the function
func (m animeMods) RomajiFunc(f func() null.Val[string]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Romaji = f
	})
}

// Clear any values for the column
func (m animeMods) UnsetRomaji() AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Romaji = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m animeMods) RandomRomaji(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Romaji = func() null.Val[string] {
			return randomNull[string](f)
		}
	})
}

func (m animeMods) ensureRomaji(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		if o.Romaji != nil {
			return
		}

		o.Romaji = func() null.Val[string] {
			return randomNull[string](f)
		}
	})
}

// Set the model columns to this value
func (m animeMods) English(val null.Val[string]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.English = func() null.Val[string] { return val }
	})
}

// Set the Column from the function
func (m animeMods) EnglishFunc(f func() null.Val[string]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.English = f
	})
}

// Clear any values for the column
func (m animeMods) UnsetEnglish() AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.English = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m animeMods) RandomEnglish(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.English = func() null.Val[string] {
			return randomNull[string](f)
		}
	})
}

func (m animeMods) ensureEnglish(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		if o.English != nil {
			return
		}

		o.English = func() null.Val[string] {
			return randomNull[string](f)
		}
	})
}

// Set the model columns to this value
func (m animeMods) Native(val null.Val[string]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Native = func() null.Val[string] { return val }
	})
}

// Set the Column from the function
func (m animeMods) NativeFunc(f func() null.Val[string]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Native = f
	})
}

// Clear any values for the column
func (m animeMods) UnsetNative() AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Native = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m animeMods) RandomNative(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Native = func() null.Val[string] {
			return randomNull[string](f)
		}
	})
}

func (m animeMods) ensureNative(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		if o.Native != nil {
			return
		}

		o.Native = func() null.Val[string] {
			return randomNull[string](f)
		}
	})
}

// Set the model columns to this value
func (m animeMods) Format(val null.Val[string]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Format = func() null.Val[string] { return val }
	})
}

// Set the Column from the function
func (m animeMods) FormatFunc(f func() null.Val[string]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Format = f
	})
}

// Clear any values for the column
func (m animeMods) UnsetFormat() AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Format = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m animeMods) RandomFormat(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Format = func() null.Val[string] {
			return randomNull[string](f)
		}
	})
}

func (m animeMods) ensureFormat(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		if o.Format != nil {
			return
		}

		o.Format = func() null.Val[string] {
			return randomNull[string](f)
		}
	})
}

// Set the model columns to this value
func (m animeMods) Status(val null.Val[string]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Status = func() null.Val[string] { return val }
	})
}

// Set the Column from the function
func (m animeMods) StatusFunc(f func() null.Val[string]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Status = f
	})
}

// Clear any values for the column
func (m animeMods) UnsetStatus() AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Status = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m animeMods) RandomStatus(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Status = func() null.Val[string] {
			return randomNull[string](f)
		}
	})
}

func (m animeMods) ensureStatus(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		if o.Status != nil {
			return
		}

		o.Status = func() null.Val[string] {
			return randomNull[string](f)
		}
	})
}

// Set the model columns to this value
func (m animeMods) Description(val null.Val[string]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Description = func() null.Val[string] { return val }
	})
}

// Set the Column from the function
func (m animeMods) DescriptionFunc(f func() null.Val[string]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Description = f
	})
}

// Clear any values for the column
func (m animeMods) UnsetDescription() AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Description = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m animeMods) RandomDescription(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Description = func() null.Val[string] {
			return randomNull[string](f)
		}
	})
}

func (m animeMods) ensureDescription(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		if o.Description != nil {
			return
		}

		o.Description = func() null.Val[string] {
			return randomNull[string](f)
		}
	})
}

// Set the model columns to this value
func (m animeMods) StartYear(val null.Val[int]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.StartYear = func() null.Val[int] { return val }
	})
}

// Set the Column from the function
func (m animeMods) StartYearFunc(f func() null.Val[int]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.StartYear = f
	})
}

// Clear any values for the column
func (m animeMods) UnsetStartYear() AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.StartYear = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m animeMods) RandomStartYear(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.StartYear = func() null.Val[int] {
			return randomNull[int](f)
		}
	})
}

func (m animeMods) ensureStartYear(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		if o.StartYear != nil {
			return
		}

		o.StartYear = func() null.Val[int] {
			return randomNull[int](f)
		}
	})
}

// Set the model columns to this value
func (m animeMods) StartMonth(val null.Val[int]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.StartMonth = func() null.Val[int] { return val }
	})
}

// Set the Column from the function
func (m animeMods) StartMonthFunc(f func() null.Val[int]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.StartMonth = f
	})
}

// Clear any values for the column
func (m animeMods) UnsetStartMonth() AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.StartMonth = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m animeMods) RandomStartMonth(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.StartMonth = func() null.Val[int] {
			return randomNull[int](f)
		}
	})
}

func (m animeMods) ensureStartMonth(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		if o.StartMonth != nil {
			return
		}

		o.StartMonth = func() null.Val[int] {
			return randomNull[int](f)
		}
	})
}

// Set the model columns to this value
func (m animeMods) StartDay(val null.Val[int]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.StartDay = func() null.Val[int] { return val }
	})
}

// Set the Column from the function
func (m animeMods) StartDayFunc(f func() null.Val[int]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.StartDay = f
	})
}

// Clear any values for the column
func (m animeMods) UnsetStartDay() AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.StartDay = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m animeMods) RandomStartDay(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.StartDay = func() null.Val[int] {
			return randomNull[int](f)
		}
	})
}

func (m animeMods) ensureStartDay(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		if o.StartDay != nil {
			return
		}

		o.StartDay = func() null.Val[int] {
			return randomNull[int](f)
		}
	})
}

// Set the model columns to this value
func (m animeMods) EndYear(val null.Val[int]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.EndYear = func() null.Val[int] { return val }
	})
}

// Set the Column from the function
func (m animeMods) EndYearFunc(f func() null.Val[int]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.EndYear = f
	})
}

// Clear any values for the column
func (m animeMods) UnsetEndYear() AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.EndYear = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m animeMods) RandomEndYear(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.EndYear = func() null.Val[int] {
			return randomNull[int](f)
		}
	})
}

func (m animeMods) ensureEndYear(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		if o.EndYear != nil {
			return
		}

		o.EndYear = func() null.Val[int] {
			return randomNull[int](f)
		}
	})
}

// Set the model columns to this value
func (m animeMods) EndMonth(val null.Val[int]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.EndMonth = func() null.Val[int] { return val }
	})
}

// Set the Column from the function
func (m animeMods) EndMonthFunc(f func() null.Val[int]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.EndMonth = f
	})
}

// Clear any values for the column
func (m animeMods) UnsetEndMonth() AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.EndMonth = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m animeMods) RandomEndMonth(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.EndMonth = func() null.Val[int] {
			return randomNull[int](f)
		}
	})
}

func (m animeMods) ensureEndMonth(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		if o.EndMonth != nil {
			return
		}

		o.EndMonth = func() null.Val[int] {
			return randomNull[int](f)
		}
	})
}

// Set the model columns to this value
func (m animeMods) EndDay(val null.Val[int]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.EndDay = func() null.Val[int] { return val }
	})
}

// Set the Column from the function
func (m animeMods) EndDayFunc(f func() null.Val[int]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.EndDay = f
	})
}

// Clear any values for the column
func (m animeMods) UnsetEndDay() AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.EndDay = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m animeMods) RandomEndDay(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.EndDay = func() null.Val[int] {
			return randomNull[int](f)
		}
	})
}

func (m animeMods) ensureEndDay(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		if o.EndDay != nil {
			return
		}

		o.EndDay = func() null.Val[int] {
			return randomNull[int](f)
		}
	})
}

// Set the model columns to this value
func (m animeMods) Season(val null.Val[string]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Season = func() null.Val[string] { return val }
	})
}

// Set the Column from the function
func (m animeMods) SeasonFunc(f func() null.Val[string]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Season = f
	})
}

// Clear any values for the column
func (m animeMods) UnsetSeason() AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Season = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m animeMods) RandomSeason(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Season = func() null.Val[string] {
			return randomNull[string](f)
		}
	})
}

func (m animeMods) ensureSeason(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		if o.Season != nil {
			return
		}

		o.Season = func() null.Val[string] {
			return randomNull[string](f)
		}
	})
}

// Set the model columns to this value
func (m animeMods) SeasonYear(val null.Val[string]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.SeasonYear = func() null.Val[string] { return val }
	})
}

// Set the Column from the function
func (m animeMods) SeasonYearFunc(f func() null.Val[string]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.SeasonYear = f
	})
}

// Clear any values for the column
func (m animeMods) UnsetSeasonYear() AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.SeasonYear = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m animeMods) RandomSeasonYear(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.SeasonYear = func() null.Val[string] {
			return randomNull[string](f)
		}
	})
}

func (m animeMods) ensureSeasonYear(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		if o.SeasonYear != nil {
			return
		}

		o.SeasonYear = func() null.Val[string] {
			return randomNull[string](f)
		}
	})
}

// Set the model columns to this value
func (m animeMods) Episodes(val null.Val[string]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Episodes = func() null.Val[string] { return val }
	})
}

// Set the Column from the function
func (m animeMods) EpisodesFunc(f func() null.Val[string]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Episodes = f
	})
}

// Clear any values for the column
func (m animeMods) UnsetEpisodes() AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Episodes = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m animeMods) RandomEpisodes(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Episodes = func() null.Val[string] {
			return randomNull[string](f)
		}
	})
}

func (m animeMods) ensureEpisodes(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		if o.Episodes != nil {
			return
		}

		o.Episodes = func() null.Val[string] {
			return randomNull[string](f)
		}
	})
}

// Set the model columns to this value
func (m animeMods) Duration(val null.Val[string]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Duration = func() null.Val[string] { return val }
	})
}

// Set the Column from the function
func (m animeMods) DurationFunc(f func() null.Val[string]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Duration = f
	})
}

// Clear any values for the column
func (m animeMods) UnsetDuration() AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Duration = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m animeMods) RandomDuration(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Duration = func() null.Val[string] {
			return randomNull[string](f)
		}
	})
}

func (m animeMods) ensureDuration(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		if o.Duration != nil {
			return
		}

		o.Duration = func() null.Val[string] {
			return randomNull[string](f)
		}
	})
}

// Set the model columns to this value
func (m animeMods) CountryOfOrigin(val null.Val[string]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.CountryOfOrigin = func() null.Val[string] { return val }
	})
}

// Set the Column from the function
func (m animeMods) CountryOfOriginFunc(f func() null.Val[string]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.CountryOfOrigin = f
	})
}

// Clear any values for the column
func (m animeMods) UnsetCountryOfOrigin() AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.CountryOfOrigin = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m animeMods) RandomCountryOfOrigin(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.CountryOfOrigin = func() null.Val[string] {
			return randomNull[string](f)
		}
	})
}

func (m animeMods) ensureCountryOfOrigin(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		if o.CountryOfOrigin != nil {
			return
		}

		o.CountryOfOrigin = func() null.Val[string] {
			return randomNull[string](f)
		}
	})
}

// Set the model columns to this value
func (m animeMods) UpdatedAt(val null.Val[int]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.UpdatedAt = func() null.Val[int] { return val }
	})
}

// Set the Column from the function
func (m animeMods) UpdatedAtFunc(f func() null.Val[int]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.UpdatedAt = f
	})
}

// Clear any values for the column
func (m animeMods) UnsetUpdatedAt() AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.UpdatedAt = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m animeMods) RandomUpdatedAt(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.UpdatedAt = func() null.Val[int] {
			return randomNull[int](f)
		}
	})
}

func (m animeMods) ensureUpdatedAt(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		if o.UpdatedAt != nil {
			return
		}

		o.UpdatedAt = func() null.Val[int] {
			return randomNull[int](f)
		}
	})
}

// Set the model columns to this value
func (m animeMods) CoverImage(val null.Val[string]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.CoverImage = func() null.Val[string] { return val }
	})
}

// Set the Column from the function
func (m animeMods) CoverImageFunc(f func() null.Val[string]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.CoverImage = f
	})
}

// Clear any values for the column
func (m animeMods) UnsetCoverImage() AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.CoverImage = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m animeMods) RandomCoverImage(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.CoverImage = func() null.Val[string] {
			return randomNull[string](f)
		}
	})
}

func (m animeMods) ensureCoverImage(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		if o.CoverImage != nil {
			return
		}

		o.CoverImage = func() null.Val[string] {
			return randomNull[string](f)
		}
	})
}

// Set the model columns to this value
func (m animeMods) AverageScore(val null.Val[int]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.AverageScore = func() null.Val[int] { return val }
	})
}

// Set the Column from the function
func (m animeMods) AverageScoreFunc(f func() null.Val[int]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.AverageScore = f
	})
}

// Clear any values for the column
func (m animeMods) UnsetAverageScore() AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.AverageScore = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m animeMods) RandomAverageScore(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.AverageScore = func() null.Val[int] {
			return randomNull[int](f)
		}
	})
}

func (m animeMods) ensureAverageScore(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		if o.AverageScore != nil {
			return
		}

		o.AverageScore = func() null.Val[int] {
			return randomNull[int](f)
		}
	})
}

// Set the model columns to this value
func (m animeMods) Popularity(val null.Val[int]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Popularity = func() null.Val[int] { return val }
	})
}

// Set the Column from the function
func (m animeMods) PopularityFunc(f func() null.Val[int]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Popularity = f
	})
}

// Clear any values for the column
func (m animeMods) UnsetPopularity() AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Popularity = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m animeMods) RandomPopularity(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.Popularity = func() null.Val[int] {
			return randomNull[int](f)
		}
	})
}

func (m animeMods) ensurePopularity(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		if o.Popularity != nil {
			return
		}

		o.Popularity = func() null.Val[int] {
			return randomNull[int](f)
		}
	})
}

// Set the model columns to this value
func (m animeMods) AiringAt(val null.Val[int]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.AiringAt = func() null.Val[int] { return val }
	})
}

// Set the Column from the function
func (m animeMods) AiringAtFunc(f func() null.Val[int]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.AiringAt = f
	})
}

// Clear any values for the column
func (m animeMods) UnsetAiringAt() AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.AiringAt = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m animeMods) RandomAiringAt(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.AiringAt = func() null.Val[int] {
			return randomNull[int](f)
		}
	})
}

func (m animeMods) ensureAiringAt(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		if o.AiringAt != nil {
			return
		}

		o.AiringAt = func() null.Val[int] {
			return randomNull[int](f)
		}
	})
}

// Set the model columns to this value
func (m animeMods) NextAiringEpisode(val null.Val[int]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.NextAiringEpisode = func() null.Val[int] { return val }
	})
}

// Set the Column from the function
func (m animeMods) NextAiringEpisodeFunc(f func() null.Val[int]) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.NextAiringEpisode = f
	})
}

// Clear any values for the column
func (m animeMods) UnsetNextAiringEpisode() AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.NextAiringEpisode = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m animeMods) RandomNextAiringEpisode(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.NextAiringEpisode = func() null.Val[int] {
			return randomNull[int](f)
		}
	})
}

func (m animeMods) ensureNextAiringEpisode(f *faker.Faker) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		if o.NextAiringEpisode != nil {
			return
		}

		o.NextAiringEpisode = func() null.Val[int] {
			return randomNull[int](f)
		}
	})
}

func (m animeMods) WithWatchlists(number int, related *WatchlistTemplate) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.r.Watchlists = []*animeRWatchlistsR{{
			number: number,
			o:      related,
		}}
	})
}

func (m animeMods) WithNewWatchlists(number int, mods ...WatchlistMod) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {

		related := o.f.NewWatchlist(mods...)
		m.WithWatchlists(number, related).Apply(o)
	})
}

func (m animeMods) AddWatchlists(number int, related *WatchlistTemplate) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.r.Watchlists = append(o.r.Watchlists, &animeRWatchlistsR{
			number: number,
			o:      related,
		})
	})
}

func (m animeMods) AddNewWatchlists(number int, mods ...WatchlistMod) AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {

		related := o.f.NewWatchlist(mods...)
		m.AddWatchlists(number, related).Apply(o)
	})
}

func (m animeMods) WithoutWatchlists() AnimeMod {
	return AnimeModFunc(func(o *AnimeTemplate) {
		o.r.Watchlists = nil
	})
}
